﻿using SocialPub.ClientModels.Resources;

using System.ComponentModel.DataAnnotations;

namespace SocialPub.ClientModels.User
{
	public class ViewUserSettings
	{
		[Required(ErrorMessageResourceName = "Required", ErrorMessageResourceType = typeof(ErrorsResource)),
				Display(Name = nameof(LanguageCode), ResourceType = typeof(FieldsNameResource))]
		public string LanguageCode { get; set; } = "en";

		[Range(0, 359, ErrorMessageResourceName = nameof(Range), ErrorMessageResourceType = typeof(ErrorsResource))]
		public short LightThemeIndexColour { get; set; } = 25;
		[Range(0, 359, ErrorMessageResourceName = nameof(Range), ErrorMessageResourceType = typeof(ErrorsResource))]
		public short DarkThemeIndexColour { get; set; } = 215;
		[Range(-2, 359, ErrorMessageResourceName = nameof(Range), ErrorMessageResourceType = typeof(ErrorsResource))]
		public short IconsThemeIndexColour { get; set; } = 25;

		public bool PreferSystemTheming { get; set; } = false;
		public bool ThemeIsDarkMode { get; set; } = false;
		public bool ThemeIsLightGray { get; set; } = false;
		public bool ThemeIsDarkGray { get; set; } = false;
	}
}