﻿using SocialPub.ClientModels;
using SocialPub.Models.User;
using SocialPub.StaticServices;

namespace SocialPub.Services.ClientToServer.Public
{
	public interface IPublicAvatarUsersService
	{
		Task<WebResult> GetAvatar(UserPolicyType userPolicyType, string actor);
		Task<WebResult> GetAvatars(UserPolicyType userPolicyType);
		Task<WebResult> GetRootAvatars();
	}

	public class PublicAvatarUsersService : IPublicAvatarUsersService
	{
		readonly DbEntities _dbEntities;

		public PublicAvatarUsersService(DbEntities dbEntities)
		{
			_dbEntities = dbEntities;
		}

		public async Task<WebResult> GetAvatar(UserPolicyType userPolicyType, string actor)
		{
			var result = new WebResult();

			var query = _dbEntities.Avatars;

			switch (userPolicyType)
			{
				case UserPolicyType.IsUser:
					query.Match(a => !a.DeletionDate.HasValue && a.UserName == actor);
					break;
				case UserPolicyType.IsModerator:
					query.Match(a => !a.DeletionDate.HasValue && a.UserName == actor);
					break;
				case UserPolicyType.IsAdmin:
					break;
			}

			return result;
		}

		public Task<WebResult> GetAvatars(UserPolicyType userPolicyType)
		{
			throw new NotImplementedException();
		}

		public Task<WebResult> GetRootAvatars()
		{
			throw new NotImplementedException();
		}
	}
}
